# 演示程序使用教程

*由于先前的 **读我文件**(README.md) 过于冗杂，现另辟蹊径来给大家全方位的教程。*

*这是演示程序的使用教程，将在这里提供演示程序的相应的使用教程*

## 视窗(Windows)操作系统

### 运行环境安装

0. 安装python3.6+

	首先需要下载Python的安装包

	> [下载64位Python安装包](https://www.python.org/ftp/python/3.8.10/python-3.8.10-amd64.exe)
	> [下载32位Python安装包](https://www.python.org/ftp/python/3.8.10/python-3.8.10.exe)
	
	在安装时，最好需要勾选 `Add Python 3.X to PATH` ，如下图所示，当然，如果您对自己非常自信，您也可以手动设置此项目：

	<img src=https://foruda.gitee.com/images/1662736520757331846/e38efb81_9911226.png>

	若您对Python一知半解或者不怎么了解、并对自己的系统盘有大约150*MB*的信心的话，您可以在安装时直接选择*快速安装*(Install Now)

	若您选择了*自定义安装*(Customize Installation)，请务必勾选 `pip` 和 `py launcher` 便于后续安装依赖，如下图：

	<img src=https://foruda.gitee.com/images/1662736621235871190/2ac3d98f_9911226.png>

	安装结束之后可以在*终端*(命令行/PowerShell/Bash/etc)中输入：python 试试是否安装成功，成功安装之后，在终端中输入python会显示诸如如下图片的提示：

	<img src=https://foruda.gitee.com/images/1659972669907359295/cmd.png>

1. 下载本代码库以及演示程序

	- 若您使用git，请直接拷贝本仓库：

	`git clone -b pkgver https://gitee.com/EillesWan/Musicreater.git`

	- 若您不使用git，可以在*码云*(Gitee)或GitHub下载zip包，或者[加入QQ群聊861684859](https://jq.qq.com/?_wv=1027&k=hpeRxrYr)，在群文件中获取。

	<img src=" https://foruda.gitee.com/images/1659972440341216712/下载.png" >

2. 安装依赖

	请以管理员模式打开您的*终端*(命令行/PowerShell/Bash/etc)

	例如，命令行，可以如此打开：在*视窗开始菜单*(Windows开始)中搜索 `cmd`, 并以管理员身份运行

	<img src="https://foruda.gitee.com/images/1662736878650993886/62487dd8_9911226.png">
	
	打开了终端之后，请在终端中输入以下指令

	`pip install mido -i https://mirrors.aliyun.com/pypi/simple/`

	`pip install brotli -i https://mirrors.aliyun.com/pypi/simple/`

	安装成功后您可能会见到类似下图的提示：

	<img src="https://foruda.gitee.com/images/1662737676719454287/f61a70f7_9911226.png">


3. 开始使用

	在目录下打开终端，例如，打开命令行，请进入到目录下，在地址框内输入cmd：
	<img src=https://foruda.gitee.com/images/1659974437388532868/输入.png>
	<img src=https://foruda.gitee.com/images/1659974754378201859/输入c.png>
	
	执行以下命令：(选择你需要的)

	`python example_convert_bdx.py`

	`python example_convert_mcpack.py`

### 补充错误说明

1. Microsoft Visual C++ Redistributable 环境出错

	如果你遇到了以下这种情况

	<img src=https://foruda.gitee.com/images/1659972789779764953/bug.jpeg>
	
	请下载最新的VCREDIST安装包，可以参照[这个网页](https://docs.microsoft.com/zh-CN/cpp/windows/latest-supported-vc-redist)的说明，也可以在这直接选择你需要的安装包下载：
	> [下载64位VCREDIST安装包](https://aka.ms/vs/17/release/vc_redist.x64.exe)
	> [下载32位VCREDIST安装包](https://aka.ms/vs/17/release/vc_redist.x64.exe)

	感谢群友Mono帮我们发现这个问题

2. 参数补充说明

	<img src=https://foruda.gitee.com/images/1659974810147043475/运行.png>

	- midi路径：含有mid文件路径、文件名、后缀的完整文件路径。可以使用相对或绝对路径皆可

	- 输出路径：输出文件夹的路径，不需要指示文件名

	- 是否重置计分板：1或0（歌曲放完是否重置，推荐1）

	- 是否启用进度条：1或0（看个人需要）

		*进度条：是否启用进度条，以及自定义进度条样式。输入0或False表示不启用进度条，输入1或True表示使用默认进度条，其余的输入均表示使用输入的格式作为自定义的进度条样式

	- 计分板名称：游戏内的计分板名称

	- 音量：0-1之间的小数（含0，1）正常来说推荐1

	- 变速：float数据，一般写1

	- 玩家选择器：包括 `@x` 在内的全部选择器，即若要选择全部标签为Holo的玩家，则需要如此输入：`@a[tag=Holo]`

	- 没有报错且在输出路径下找到mcpack或bdx即为生成成功：

	<img src=https://foruda.gitee.com/images/1659973655881460036/输出.png>